package com.hammingweight.hammockexamples.example2;

import java.util.Enumeration;
import java.util.Hashtable;

import com.hammingweight.hammock.IArgumentMatcher;

public class HashtableMatcher implements IArgumentMatcher {

	public boolean areArgumentsEqual(Object expected, Object actual) {
		if (!(actual instanceof Hashtable)) {
			return false;
		}
		
		Hashtable e = (Hashtable) expected;
		Hashtable a = (Hashtable) actual;
		
		if (e.size() != a.size()) {
			return false;
		}
		
		Enumeration en = e.keys();
		while (en.hasMoreElements()) {
			Object key = en.nextElement();
			if (!e.get(key).equals(a.get(key))) {
				return false;
			}
		}
		return true;
	}

}
